//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3EA06DB0012A.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EA06DB0012A.cm

//## begin module%3EA06DB0012A.cp preserve=no
//## end module%3EA06DB0012A.cp

//## Module: Step%3EA06DB0012A; Package specification
//## Subsystem: XSFit::Fit%3677C9158350
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/Fit/Step.h

#ifndef STEP_H
#define STEP_H 1

//## begin module%3EA06DB0012A.additionalIncludes preserve=no
//## end module%3EA06DB0012A.additionalIncludes

//## begin module%3EA06DB0012A.includes preserve=yes
//## end module%3EA06DB0012A.includes

// memory
#include <memory>
// Grid
#include <XSFit/Fit/Grid.h>

class Fit;

//## begin module%3EA06DB0012A.declarations preserve=no
//## end module%3EA06DB0012A.declarations

//## begin module%3EA06DB0012A.additionalDeclarations preserve=yes
//## end module%3EA06DB0012A.additionalDeclarations


//## begin Step%3EA06B7502E9.preface preserve=yes
//## end Step%3EA06B7502E9.preface

//## Class: Step%3EA06B7502E9
//## Category: XSFit::Fit%36349D710188
//## Subsystem: XSFit::Fit%3677C9158350
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3EA9A9A201F4;Fit { -> F}

class Step : public Grid  //## Inherits: <unnamed>%41F91DBD034D
{
  //## begin Step%3EA06B7502E9.initialDeclarations preserve=yes
  //## end Step%3EA06B7502E9.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: Step%41F91AC2012E
      Step (Fit* fit);

    //## Destructor (generated)
      virtual ~Step();


    //## Other Operations (specified)
      //## Operation: doGrid%3EA9A90700D1
      virtual void doGrid ();

      //## Operation: retrieveParameter%3EAE923D0298
      static void retrieveParameter (const Fit* fit, const string& paramIDStr, ModParam*& parameter, int& paramIndex, int& fullIndex, string& paramName);

      //## Operation: report%3EDCD40201AC
      virtual void report (bool title) const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: best%3EA06BB3019F
      bool best () const;
      void best (bool value);

      //## Attribute: bestFit%3ECBB2D40067
      //	bestFit is the fit statistic value at the start of the
      //	steppar run.  Its name is misleading if the user runs
      //	steppar when the fit is not up-to-date (which wasn't
      //	allowed in the original steppar implementation).
      Real bestFit () const;
      void bestFit (Real value);

      //## Attribute: minStatFound%4A2010D502D6
      //	This is the saved value of the minimum fit statistic
      //	found during the most recent steppar run.
      Real minStatFound () const;

      //## Attribute: minStatParams%4A24175500BD
      //	These are the values of ALL the variable fit parameters
      //	at the time of minStatFound, keyed by parameter index.
      //	Both the frozen stepped parameters and non-frozen other
      //	fit parameters are included here.  Use CAUTION if
      //	accessing this sometime after the last steppar, as
      //	parameter indices may no longer be valid.
      const std::map<int,Real>& minStatParams () const;

    // Additional Public Declarations
      //## begin Step%3EA06B7502E9.public preserve=yes
      //## end Step%3EA06B7502E9.public

  protected:
    // Additional Protected Declarations
      //## begin Step%3EA06B7502E9.protected preserve=yes
      //## end Step%3EA06B7502E9.protected

  private:
    //## Constructors (generated)
      Step(const Step &right);

    //## Assignment Operation (generated)
      Step & operator=(const Step &right);


    //## Other Operations (specified)
      //## Operation: stepThruDimension%3EB27C43025F
      void stepThruDimension (int dimension, int point, IntegerArray& coordinates);

      //## Operation: restoreFit%3EB2C3C80335
      void restoreFit ();

      //## Operation: doPoint%3EB6BA0602EE
      virtual void doPoint ();

    // Additional Private Declarations
      //## begin Step%3EA06B7502E9.private preserve=yes
      //## end Step%3EA06B7502E9.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin Step::best%3EA06BB3019F.attr preserve=no  public: bool {U} 
      bool m_best;
      //## end Step::best%3EA06BB3019F.attr

      //## begin Step::bestFit%3ECBB2D40067.attr preserve=no  public: Real {U} 
      Real m_bestFit;
      //## end Step::bestFit%3ECBB2D40067.attr

      //## Attribute: fit%41F91A6401C2
      //## begin Step::fit%41F91A6401C2.attr preserve=no  private: Fit* {U} 
      Fit* m_fit;
      //## end Step::fit%41F91A6401C2.attr

      //## Attribute: increasing%41F9214A0091
      //## begin Step::increasing%41F9214A0091.attr preserve=no  private: BoolArray {U} 
      BoolArray m_increasing;
      //## end Step::increasing%41F9214A0091.attr

      //## begin Step::minStatFound%4A2010D502D6.attr preserve=no  public: Real {U} 
      Real m_minStatFound;
      //## end Step::minStatFound%4A2010D502D6.attr

      //## begin Step::minStatParams%4A24175500BD.attr preserve=no  public: std::map<int,Real> {U} 
      std::map<int,Real> m_minStatParams;
      //## end Step::minStatParams%4A24175500BD.attr

    // Additional Implementation Declarations
      //## begin Step%3EA06B7502E9.implementation preserve=yes
      //## end Step%3EA06B7502E9.implementation

};

//## begin Step%3EA06B7502E9.postscript preserve=yes
//## end Step%3EA06B7502E9.postscript

// Class Step 

//## Get and Set Operations for Class Attributes (inline)

inline bool Step::best () const
{
  //## begin Step::best%3EA06BB3019F.get preserve=no
  return m_best;
  //## end Step::best%3EA06BB3019F.get
}

inline void Step::best (bool value)
{
  //## begin Step::best%3EA06BB3019F.set preserve=no
  m_best = value;
  //## end Step::best%3EA06BB3019F.set
}

inline Real Step::bestFit () const
{
  //## begin Step::bestFit%3ECBB2D40067.get preserve=no
  return m_bestFit;
  //## end Step::bestFit%3ECBB2D40067.get
}

inline void Step::bestFit (Real value)
{
  //## begin Step::bestFit%3ECBB2D40067.set preserve=no
  m_bestFit = value;
  //## end Step::bestFit%3ECBB2D40067.set
}

inline Real Step::minStatFound () const
{
  //## begin Step::minStatFound%4A2010D502D6.get preserve=no
  return m_minStatFound;
  //## end Step::minStatFound%4A2010D502D6.get
}

inline const std::map<int,Real>& Step::minStatParams () const
{
  //## begin Step::minStatParams%4A24175500BD.get preserve=no
  return m_minStatParams;
  //## end Step::minStatParams%4A24175500BD.get
}

//## begin module%3EA06DB0012A.epilog preserve=yes
//## end module%3EA06DB0012A.epilog


#endif
